Raspberry-Pi mini home server 101- Μερος 3ο : Εγκατάσταση και ρύθμιση kodi media center

Αφού έχουμε προχωρήσει στην αρχική παραμετροποίηση του raspberry pi μας στο Raspberry-Pi mini home server 101- Μερος 2ο , ήρθε η ώρα να δώσουμε εικόνα στο media player μας, και ποιος καλύτερος τρόπος από το να βάλουμε το kodi media player.

Επιλέξαμε το KODI για βάση του γραφικού περιβάλλοντος του raspberry pi για 2 βασικούς λόγους.

Αρχικά το kodi έχει standalone mode, κατά το οποίο δεν χρειάζεται να φορτώσει το raspberrypi γραφικό περιβάλλον για να τρέξει. Έτσι μπορούμε να έχουμε ένα πλήρες media center στημένο απευθείας πάνω στο Raspbian lite  χωρίς την χρήση κάποιου greeter ή GUI (pixel, gnome, xfce etc).

Δεύτερον και σημαντικότερο, το kodi παρέχει άριστη υποστήριξη σε χειρισμό με τηλεχειρηστήριο τηλεόρασης, και σε συνδυασμό της “outofthebox” υποστήριξης του προτύπου HDMI-CEC απο το RaspberryPi, σε κάθε σύγχρονη τηλεόραση θα μπορούμε να χρησιμοποιήσουμε το χειριστήριο της για το media center μας

Για την εγκατάσταση του kodi συνδεόμαστε οπως πάντα μεσω SSH στο server μας και τρέχουμε την παρακάτω εντολή

sudo apt-get install kodi

Έπειτα χρειαζόμαστε 2 αρχεία που θα επιτρέπουν στο kodi να ενεργοποιείται κατά την εκκίνηση του συστήματος.

Δημιουργούμε το /etc/default/kodi λοιπόν και μέσα βάζουμε τα παρακάτω

#για αυτόματη εκκίνηση
ENABLED=1
#Ο χρήστης του server μας (προεπιλογή είναι ο pi)
USER=pi
#προτεραιότητα του service (όσο μικρότερο νούμερο τόσο μεγαλύτερη προτεραιότητα)
NICE=-5

Έπειτα δημιουργούμε και το script εκκίνησης /etc/init.d/kodi στο οποίο βάζουμε μέσα τα παρακάτω. (source: Github/Cyberek)

#! /bin/sh
### BEGIN INIT INFO
# Provides:          kodi
# Required-Start:    $remote_fs $syslog
# Required-Stop:     $remote_fs $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: XBMC media centre
# Description:       Starts the XBMC media centre in standalone mode
### END INIT INFO

# Author: Michael Gorven <michael@gorven.za.net>

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="media centre"
NAME=kodi
STARTAS=/usr/bin/kodi-standalone
DAEMON=/bin/sh
DAEMON_ARGS=""
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
GEOMETRY=/var/run/kodi.fbset

# Defaults
ENABLED=0
USER=kodi
NICE=0

# Exit if the package is not installed
[ -x "$STARTAS" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Backwards compatibility with previous package name
[ -r /etc/default/xbmc ] && . /etc/default/xbmc

# Exit if service is not enabled
[ "$ENABLED" = "1" ] || exit 0

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
        fbset --show | grep geometry | cut -d' ' -f 6- > $GEOMETRY
        # Return
        #   0 if daemon has been started
        #   1 if daemon was already running
        #   2 if daemon could not be started
        start-stop-daemon --start --quiet --pidfile $PIDFILE --user $USER --exec $DAEMON --startas $STARTAS --test > /dev/null \
                || return 1
        start-stop-daemon --start --quiet --pidfile $PIDFILE --nicelevel $NICE --chuid $USER --background --make-pidfile --exec $DAEMON --startas $STARTAS -- \
                $DAEMON_ARGS \
                || return 2
        # Add code here, if necessary, that waits for the process to be ready
        # to handle requests from services started subsequently which depend
        # on this one.  As a last resort, sleep for some time.
        sleep 10
        start-stop-daemon --start --quiet --pidfile $PIDFILE --user $USER --exec $DAEMON --startas $STARTAS --test > /dev/null \
                || return 2
}

#
# Function that stops the daemon/service
#
do_stop()
{
        # Return
        #   0 if daemon has been stopped
        #   1 if daemon was already stopped
        #   2 if daemon could not be stopped
        #   other if a failure occurred
        start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --user $USER --exec $DAEMON --startas $STARTAS

        # Kodi doesn't actually handle signals, so we have to send an RPC request to ask it to exit
        if [ -x /usr/bin/wget ]; then
                wget --post-data '{"jsonrpc": "2.0", "method": "Application.Quit", "params": [], "id": 0}' --header 'Content-Type: application/json' -O /dev/null --quiet http://localhost:8080/jsonrpc
        fi
        # Wait for children to finish too if this is a daemon that forks
        # and if the daemon is only ever run from this initscript.
        # If the above conditions are not satisfied then add some other code
        # that waits for the process to drop all resources that could be
        # needed by services started subsequently.  A last resort is to
        # sleep for some time.
        start-stop-daemon --stop --quiet --retry=0/30/KILL/5 --user $USER --name $NAME.bin
        RETVAL="$?"
        [ "$RETVAL" = 2 ] && return 2

        # Many daemons don't delete their pidfiles when they exit.
        rm -f $PIDFILE

        # Try to fix the display
        VT="$(fgconsole)"
        if [ "$VT" ]; then
                chvt 7
                chvt "$VT"
        fi

        if [ -e $GEOMETRY ]; then
                fbset --geometry $(cat $GEOMETRY)
        fi

        return "$RETVAL"
}

case "$1" in
  start)
        [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
        do_start
        case "$?" in
                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
  stop)
        [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
        do_stop
        case "$?" in
                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
  status)
        status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
        ;;
  restart|force-reload)
        #
        # If the "reload" option is implemented then remove the
        # 'force-reload' alias
        #
        log_daemon_msg "Restarting $DESC" "$NAME"
        do_stop
        case "$?" in
          0|1)
                do_start
                case "$?" in
                        0) log_end_msg 0 ;;
                        1) log_end_msg 1 ;; # Old process is still running
                        *) log_end_msg 1 ;; # Failed to start
                esac
                ;;
          *)
                # Failed to stop
                log_end_msg 1
                ;;
        esac
        ;;
  *)
        echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
        exit 3
        ;;
esac

:

Τέλος αλλάζουμε στο script τα δικαιώματα κάνοντάς το εκτελέσιμο

sudo chmod +x /etc/init.d/kodi

και εγκαθιστούμε το Script εκκίνησης στο σύστημα με την παρακάτω εντολή.

sudo update-rc.d kodi defaults

Πριν κάνουμε restart είναι καλό να κάνουμε μια ακόμα ρύθμιση για να βοηθήσουμε το raspberypi να ανταπεξέλθει στην αναπαραγωγή FullHD.

Μπαίνουμε στο εργαλείο διαχείρισης του raspberry , raspi-config και ρυθμίζουμε την μνήμη που δίνει το σύστημα στο υποσύστημα γραφικών να είναι στα 256MB.

sudo raspi-config

Κάνουμε restart to σύστημα και αν όλα είναι σωστά στην τηλεόραση μας , αντί το login prompt του Linux, θα δούμε να εμφανίζεται το αρχικό μενού του KODI.

Σχολιαστε

Αφήστε μια απάντηση

Η ηλ. διεύθυνση σας δεν δημοσιεύεται.

Συντακτης
Dimitris Valilis
Ενθουσιώδης με την τεχνολογία, gamer και casual μπλόγκερ, απο μικρό παιδί προσπαθώ να ενημερώνομαι για νέες τεχνολογίες και να δοκιμάζω καινούρια πράγματα. Γράφω στο blog για να εκφράσω την άποψή μου, αλλα και για να σημειώσω πράγματα που μελλοντικά θα ψάχνω. Ενθουσιάζομαι με προγραμματιστικά και κατασκευαστικά projects και αφιερώνω τον ελεύθερο μου χρόνο στις 3D-Κατασκευές και τον σχεδιασμο/υλοποίηση και διαχείριση συστημάτων τεχνολογίας υπολογιστών.
Επικοινωνια

: Email
: Facebook
: Instagram

Created and maintained by doomster. All rights reserved.